<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfActivityVersionResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfActivityVersionResult_V5 extends AbstractStructArrayBase
{
    /**
     * The ActivityVersionResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ActivityVersionResult_V5[]
     */
    public $ActivityVersionResult_V5;
    /**
     * Constructor method for ArrayOfActivityVersionResult_V5
     * @uses ArrayOfActivityVersionResult_V5::setActivityVersionResult_V5()
     * @param \StructType\ActivityVersionResult_V5[] $activityVersionResult_V5
     */
    public function __construct(array $activityVersionResult_V5 = array())
    {
        $this
            ->setActivityVersionResult_V5($activityVersionResult_V5);
    }
    /**
     * Get ActivityVersionResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ActivityVersionResult_V5[]|null
     */
    public function getActivityVersionResult_V5()
    {
        return isset($this->ActivityVersionResult_V5) ? $this->ActivityVersionResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setActivityVersionResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setActivityVersionResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateActivityVersionResult_V5ForArrayConstraintsFromSetActivityVersionResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfActivityVersionResult_V5ActivityVersionResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfActivityVersionResult_V5ActivityVersionResult_V5Item instanceof \StructType\ActivityVersionResult_V5) {
                $invalidValues[] = is_object($arrayOfActivityVersionResult_V5ActivityVersionResult_V5Item) ? get_class($arrayOfActivityVersionResult_V5ActivityVersionResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfActivityVersionResult_V5ActivityVersionResult_V5Item), var_export($arrayOfActivityVersionResult_V5ActivityVersionResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ActivityVersionResult_V5 property can only contain items of type \StructType\ActivityVersionResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ActivityVersionResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ActivityVersionResult_V5[] $activityVersionResult_V5
     * @return \ArrayType\ArrayOfActivityVersionResult_V5
     */
    public function setActivityVersionResult_V5(array $activityVersionResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($activityVersionResult_V5ArrayErrorMessage = self::validateActivityVersionResult_V5ForArrayConstraintsFromSetActivityVersionResult_V5($activityVersionResult_V5))) {
            throw new \InvalidArgumentException($activityVersionResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($activityVersionResult_V5) || (is_array($activityVersionResult_V5) && empty($activityVersionResult_V5))) {
            unset($this->ActivityVersionResult_V5);
        } else {
            $this->ActivityVersionResult_V5 = $activityVersionResult_V5;
        }
        return $this;
    }
    /**
     * Add item to ActivityVersionResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\ActivityVersionResult_V5 $item
     * @return \ArrayType\ArrayOfActivityVersionResult_V5
     */
    public function addToActivityVersionResult_V5(\StructType\ActivityVersionResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ActivityVersionResult_V5) {
            throw new \InvalidArgumentException(sprintf('The ActivityVersionResult_V5 property can only contain items of type \StructType\ActivityVersionResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ActivityVersionResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ActivityVersionResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ActivityVersionResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ActivityVersionResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ActivityVersionResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ActivityVersionResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ActivityVersionResult_V5
     */
    public function getAttributeName()
    {
        return 'ActivityVersionResult_V5';
    }
}
